#pragma once
#include "fs/devices/DeviceRegistry.h"

class ConsoleDevice : public Device
{
  public:
    // Initializer for DeviceRegistry.
    static Result<SharedPtr<Device>> create();

    Result<usize> read(u8*, usize, usize) const override;

    Result<usize> write(const u8*, usize, usize) override;

    static void did_press_key(char key);

    bool blocking() const override;

    virtual ~ConsoleDevice() = default;
};
